c
c**********************************************************************************
c
C     MISCELLANEOUS FUNCTIONS/SUBROUTINUES
c
      SUBROUTINE ESD(SM,V,SUM)
      include 'param.inc'
      DIMENSION SM(6,6),V(6),S(6),R(6),E(6)
      I=0
      DO 1 IA=1,3
      I=I+1
      IB=IA+1
      IF(IB.GT.3)IB=IB-3
      IC=IB+1
      IF(IC.GT.3)IC=IC-3
      ID=IA+3
      IE=IB+3
      IP=IC+3
      FNUM=4.*V(IB)*V(IC)-V(ID)*V(ID)
      DEN=4.*V(IA)*V(IB)*V(IC)-V(IA)*V(ID)*V(ID)-V(IB)*V(IE)*V(IE)-V(IC)
     1*V(IP)*V(IP)+V(ID)*V(IE)*V(IP)
      S(I)=SQRT(FNUM/DEN)
      R(IA)=-S(I)**4
      DENL=1./(DEN*DEN)
      R(IB)=DENL*(4.*V(IC)*DEN-(4.*V(IA)*V(IC)-V(IE)*V(IE))*FNUM)
      R(IC)=DENL*(4.*V(IB)*DEN-(4.*V(IA)*V(IB)-V(IP)*V(IP))*FNUM)
      R(ID)=-DENL*(2.*V(ID)*DEN-(2.*V(IA)*V(ID)-V(IE)*V(IP))*FNUM)
      R(IE)=DENL*FNUM*(2.*V(IB)*V(IE)-V(ID)*V(IP))
      R(IP)=DENL*FNUM*(2.*V(IC)*V(IP)-V(ID)*V(IE))
      E(I)=ERROR(SM(1,1),R(1),SUM)
      E(I)=E(I)/(2.*S(I))
      FNUM=V(IE)*V(IP)-2.*V(IA)*V(ID)
      DEN=16.*V(IA)*V(IA)*V(IB)*V(IC)+V(IE)*V(IE)*V(IP)*V(IP)-4.*(V(IA)*
     1V(IB)*V(IE)*V(IE)+V(IC)*V(IA)*V(IP)*V(IP))
      DENL=1./(DEN*DEN)
      FNUML=FNUM*FNUM
      S(I+3)=FNUML/DEN
      R(IA)=-4.*FNUM*DENL*(V(ID)*DEN+FNUM*(8.*V(IA)*V(IB)*V(IC)-V(IB)*V(
     1IE)*V(IE)-V(IC)*V(IP)*V(IP)))
      R(IB)=-4.*FNUML*DENL*(4.*V(IA)*V(IA)*V(IC)-V(IA)*V(IE)*V(IE))
      R(IC)=-4.*FNUML*DENL*(4.*V(IA)*V(IA)*V(IB)-V(IA)*V(IP)*V(IP))
      R(ID)=-4.*FNUM/DEN*V(IA)
      R(IE)=2.*FNUM*DENL*(V(IP)*DEN-FNUM*(V(IE)*V(IP)*V(IP)-4.*V(IA)*V(I
     1B)*V(IE)))
      R(IP)=2.*FNUM*DENL*(V(IE)*DEN-FNUM*(V(IE)*V(IE)*V(IP)-4.*V(IC)*V(I
     1A)*V(IP)))
      E(I+3)=ERROR(SM(1,1),R(1),SUM)
      IF(S(I+3).EQ.0.0) GOTO 3
      E(I+3)=E(I+3)/(2.*SQRT(S(I+3)*(1.-S(I+3))))*180./3.14159265359
      S(I+3)=ATAN(SQRT((1.-S(I+3))/S(I+3)))*180./3.14159265359
      GOTO 4
    3 S(I+3)=90.
      E(I+3)=0.0
    4 CONTINUE
      IF(FNUM.LT.0.)S(I+3)=180.-S(I+3)
      IF(SM(ID,ID).EQ.0.)E(ID)=0.
    1 CONTINUE
      IF(ABS(S(1)-S(2)).LT..00008)E(1)=E(2)
      DO 2 I=1,6
      SM(I,I)=E(I)
    2 V(I)=S(I)
      RETURN
      END
c
c**********************************************************************************
c
c
      FUNCTION ERROR(A,B,OMEGA)
      include 'param.inc'
      DIMENSION A(6,6),B(6)
      SUM=0.
      DO 1 I=1,6
      DO 1 J=I,6
      X=2.
      IF(I.EQ.J)X=1.
    1 SUM=SUM+A(I,J)*B(I)*B(J)*X
      IF(SUM.LT.0.)SUM=0.
      ERROR=SQRT(SUM*OMEGA)
      RETURN
      END
c
c**********************************************************************************
c
C         MATRIX INVERSION
      FUNCTION DPINV(A1,B1,N)
      include 'param.inc'
      DOUBLE PRECISION A,B,U,T
      DIMENSION A(MSZ,MSZ),A1(MSZ,MSZ),B(MSZ),B1(MSZ),U(MSZ),M(MSZ)
      IF(N.NE.1)GOTO 50
      A1(1,1)=1./A1(1,1)
      B1(1)=B1(1)*A1(1,1)
      DPINV=1
      GOTO 99
   50 DPINV=0
c
      DO 1 I=1,N
        B(I)=B1(I)
        DO 1 J=1,N
    1     A(I,J)=A1(I,J)
c
      DO 2 I=1,N
      U(I)=DABS(A(I,1))
      C=U(I)
      DO 3 J=2,N
      U(I)=DMAX1(U(I),DABS(A(I,J)))
    3 C=C+DABS(A(I,J))
      DPINV=AMAX1(DPINV,C)
      M(I)=I
      B(I)=B(I)/U(I)
      DO 2 J=1,N
    2 A(I,J)=A(I,J)/U(I)
      DO 10 I=1,N
      IF(I.EQ.N)GOTO 15
      J=I
      I1=I+1
      MI=M(I)
      S=DABS(A(MI,I))
      DO 4 K=I1,N
      MI=M(K)
      IF(DABS(A(MI,I)).LE.S)GOTO 4
      S=DABS(A(MI,I))
      J=K
    4 CONTINUE
      MK1=M(J)
      M(J)=M(I)
      M(I)=MK1
   15 MI1=M(I)
      A(MI1,I)=1./A(MI1,I)
      B(MI1)=B(MI1)*A(MI1,I)
      DO 20 J=1,N
      IF(I.EQ.J)GOTO 20
      A(MI1,J)=A(MI1,J)*A(MI1,I)
   20 CONTINUE
      DO 30 J=1,N
      IF(J.EQ.I)GOTO 30
      MJ=M(J)
      T=A(MJ,I)
      MI1=M(I)
      B(MJ)=B(MJ)-T*B(MI1)
      A(MJ,I)=-T*A(MI1,I)
      DO 40 K=1,N
      IF(K.EQ.I)GOTO 40
      A(MJ,K)=A(MJ,K)-T*A(MI1,K)
   40 CONTINUE
   30 CONTINUE
   10 CONTINUE
      DO 93 I=1,N
      MI1=M(I)
      B1(I)=B(MI1)
      DO 94 J=1,N
      MJ=M(J)
   94 A1(I,MJ)=A(MI1,J)/U(MJ)
   93 CONTINUE
      C=0
      DO 91 I=1,N
      D=ABS(A1(I,1))
      DO 92 J=2,N
   92 D=D+ABS(A1(I,J))
   91 C=AMAX1(C,D)
      DPINV=DPINV*C
   99 RETURN
      END
c                         
