c      Calulates the desired frequency range for the FFT
      function FreqUpLimit(HG,HL)
	real HG,HL
      FreqUpLimit = Max(Sqrt(HG**2/(16*log(2.0))), HL/2, -6.0*log(10.0)) 
      return
      end
c
c
      subroutine IKEDA_VOIGT(DELTA, HL, HG, ALPHA, BETA, RV)
	REAL DELTA, HL, HG, ALPHA, BETA, RV
	COMPLEX I,F1,F2,F3,F4,FVAL
	COMPLEX DER_HL,DER_HG,DER_ALPHA,DER_BETA,DER_RV,DER_ZERO
	I = CMPLX(0.0,1.0)
      F1 = EXP(-HL*ABS(DELTA)*0.5)
	F2 = EXP(-(HG*DELTA)**2/(16*LOG(2.0)))
	F3 = (ALPHA/(ALPHA - I*DELTA))**3
	F4 = 1.0 + RV*(BETA/(BETA-I*DELTA) - 1)
	FVAL = F1*F2*F3*F4
	DER_HL = -ABS(DELTA)*FVAL*0.5
      DER_HG = -(HG/(8*LOG(2.0)))*(DELTA**2)*FVAL
      DER_ALPHA = 3*I*DELTA/(ALPHA-I*DELTA)**2 *F1*F2*F4 * FVAL**2
      DER_BETA = -I*DELTA/(BETA-I*DELTA)**2 *RV*F1*F2*F3
	DER_RV = -I*DELTA/(BETA-I*DELTA)**2 * F1*F2*F3
	DER_ZERO = -I*DELTA*FVAL
	RETURN
	END