c
c**********************************************************************************
c
c         console routinues
c
      PROGRAM LHPMCON
      include 'param.inc'
      REAL LAMDA
      INTEGER PTR
      CHARACTER FNAME*250,FTEMP*250
      INTEGER NDS,LC,I,ERROR,ERR2,IMCYCLE,IFINISH
      COMMON/DC/SAVE(NUPH,6),NSAVE
      INTEGER, Pointer::  IREFS(:,:),ICX(:,:)
      REAL, POINTER:: REFS(:,:,:),FF(:,:)
      COMMON/REFLS/IREFS,REFS,FF,ICX
      COMMON/G1/THMIN(MAXDS),STEP(MAXDS),THMAX(MAXDS),U(MAXDS),
     &  V(MAXDS),W(MAXDS),LAMDA(MAXDS,2),TMV(MAXDS),CTHM(MAXDS),
     &  RLIM,SB,WDT(MAXDS),UU(MAXDS),VV(MAXDS),WW(MAXDS),FFLIM(MAXDS),                              
     &  IABSCOR(MAXDS),IFULLILL(MAXDS),IGEOM(MAXDS)
      COMMON/CNTRLS/JOBTYP(MAXDS),NPROF(MAXDS),NPHASE,IOT,IPL,IPC,MAT,
     *NXT,LST1,LST2,LST3,IPL1,IPL2,MCYCLE,EPS,MAXS,IFOUR,NFMT,LSYNC,
     *LMR,IDSBB,IBCK,IPREF,ITHER,RADMIN,RADMAX,NMOLE,NRES,IMARQT,VMARQT
      COMMON/PARAMS/GLB(MAXGP),AGLB(MAXGP),LGLB(MAXGP),PAR(NUPH,MAXAP),
     *APAR(NUPH,MAXAP),LPAR(NUPH,MAXAP),XL(NATS,14),LP(NATS,14),
     *A(NATS,14),PTR(MAXDS,NATS),RELAX(4),RATIO(MAXDS,2),IPTYPE(NUPH)
      CHARACTER*4 ATEXT(NATS),NTYP(NATS)
      COMMON/PARAC/ATEXT,NTYP
      COMMON/JNK/ALOW(MAXDS,MAXEXCL),AHIGH(MAXDS,MAXEXCL),
     *POS(MAXDS,MAXBK),BCK(MAXDS,MAXBK),NATOM(NUPH),PREF(MAXDS,NUPH,3),
     *NBCKGD(MAXDS),IWT(MAXDS),NEXCRG(MAXDS),NSCAT(MAXDS)
      COMMON/ANISO/ ANHKL(MAXDS,NUPH,3),IAP(MAXDS) 
      CHARACTER SYMB(NUPH,20)*1
      CHARACTER TITLE*80,PHSNM(NUPH)*80
      COMMON/CHAR/SYMB,TITLE,PHSNM
      COMMON/COEFF/AC(MAXDS,10,MAXFF),POSI(MFCO,MAXFF),SCAT(MFCO,MAXFF),
     *DFP(MAXDS,MAXFF,2),DFPP(MAXDS,MAXFF)
      CHARACTER*4 NAM(MAXDS,MAXFF)
      COMMON/COEFC/NAM
      REAL, Pointer::  Y(:,:),YC(:,:),BK(:,:),WT(:,:)
      INTEGER, Pointer::  NPTS(:),KR(:,:)
      COMMON/DATAX/Y,YC,KR,BK,NPTS,WT
      COMMON/RTMTX/IVEC(NUPH,192),MLT(NUPH),ICET(NUPH),IPHMULT(NUPH)
      COMMON/FILEINT/LC,LT,FNAME,FTEMP
c      REAL RS(0:127,0:127)
      CHARACTER CIDSZ*10,CIRS*10
C         GETS VALUES FOR IDSZ AND IRS FROM ENVIRONMENT VARIABLES, ELSE DEFAULTS TO VALUES
      IDSZ = IIDSZ	
      IRS = IIRS	
	CALL GETENV('IDSZ',CIDSZ)
	CALL GETENV('IRS',CIRS)
	READ(CIDSZ,*,ERR = 30) IDSZ
	GOTO 31
   30 IDSZ = 10000
   31 READ(CIRS,*,ERR=32) IRS
      GOTO 33
   32 IRS = 4000	
   33 CONTINUE
      if (idsz.le.1000) idsz = IIDSZ
      if (irs.le.300) irs = IIRS
      write(*,93)
      write(*,*)            '          LHPM - Rietveld Analysis'
      write(*,'(A30,F5.2)') '                Version: ',VERSION
      WRITE(*,91) MAXDS,NUPH
      WRITE(*,92) IDSZ,IRS      
      WRITE(*,94) NATS,NIPOI      
      write(*,93)
      WRITE(*,*)
   93 format(58(1H*))
   91 format(' Number of Histograms: ',i6,
     *'  Number of Phases:     ',i5)          
   92 format(' Number of DataPoints: ',i6,
     *'  Number of Reflections:',i5)          
   94 format(' Number of Atoms:      ',i6,
     *'  Number of Refls/Point:',i5)          
    9 format(1X,A,$)
      IF (IARGC().EQ.1) THEN
          call getarg(1,fname,LC)                                           !PC (MS-FORTAN 4.0)
c          call getarg(1,fname)                                             !UNIX/SGI (VAX?)
      ELSE 
          write(*,9) 'Enter filename (no extension):'
          read(*,'(A)') fname
      ENDIF
        i = 0
   19   continue
        i = i + 1
        if ((fname(i:i).eq.' ').or.(i.eq.len(fname))) goto 21
        goto 19
   21   lc = i-1             
        
      open(unit=5,file=fname(1:lc)//'.inp',ERR=20,status='OLD')            !input file
      open(unit=6,file=fname(1:lc)//'.out',status='UNKNOWN')               !output file
      open(unit=7,file='USER')                                            !PC specific (for console output)
c      open(unit=7,file='SYS$OUTPUT',status='UNKNOWN')                      !VAX  (for console output)
c      open(unit=7,file='/dev/tty',status='UNKNOWN')                        !SGI/UNIX (for console output)
      CALL INPTR(NDS,IDSZ,IRS,ERROR)                                                     !RETURNS NDS  
      IF (ERROR.NE.0) GOTO 998
      IF (NXT.NE.0) THEN
         open(unit=8,file=fname(1:lc)//'.upd',status='UNKNOWN')              !updated file
      ENDIF
      IF (IFOUR.NE.0) THEN
         open(unit=20,file=fname(1:lc)//'.fou',status='UNKNOWN')             !fourier file
      ENDIF
      IF (IPL2.NE.0) THEN
         open(unit=9,file=fname(1:lc)//'.plt',status='UNKNOWN')
      ENDIF
      DO I=1,NDS                                   
         CALL ASSIGN(I,IDSZ,IRS,ERROR)                                                  !ASSIGN REFLECTION TO DATA
         IF (ERROR.NE.0) EXIT
      ENDDO
      IF (ERROR.NE.0) GOTO 998
      WRITE(7,*) 'Starting refinement...'
      DO IMCYCLE=1,MCYCLE
          CALL ITER(NDS,IRS,IMCYCLE,IFINISH,ERROR)                                                      !ITERATE OVER THE NDS DATASETS
          IF (IFINISH.EQ.1) EXIT
          IF (ERROR.NE.0) EXIT
      ENDDO
      IF (ERROR.NE.0) GOTO 998
      write(7,*) 'Finishing refinement...'
      DO I=1,NDS                                       
          CALL EXPUT(I,IDSZ,NDS,ERROR)
          IF (ERROR.NE.0) EXIT
      ENDDO
      IF ((RADMIN.NE.0).OR.(RADMAX.NE.0)) THEN
          WRITE(7,*) 'Writing bond file...'
          open(unit=10,file=fname(1:lc)//'.dst',status='UNKNOWN')         !DISTANCES
          OPEN(UNIT=11,file=FNAME(1:LC)//'.ang',STATUS='UNKNOWN')
          DO 1000 I=1,NPHASE
 1000         CALL BONDGEN(I,RADMIN,RADMAX)
          CLOSE(UNIT=10)
          CLOSE(UNIT=11)
      ENDIF
C      CALL FOURIER(1,1,64,63,1,2,3,0,0,VMIN,VMAX,RS)      
      GOTO 998
   20 ERROR=1

  998 CALL DALCMEMORY(ERR2)
      close(unit =2)
      close(unit =5)
      close(unit =6)
      close(unit =7)
      close(unit =8)
      close(unit =20)
	CLOSE(UNIT=21)
      close(unit =9)
      IF (ERROR.NE.0) THEN
      IF (ERROR.EQ.1) WRITE(*,*) 'ERROR OPENING DATAFILE'
      IF (ERROR.EQ.6) WRITE(*,*) 'ERROR OPENING DATAFILE'
      IF (ERROR.EQ.22) write(*,*) 'ERROR IN THETA ANGLES OF DATA FILEE'
      IF (ERROR.EQ.21) write(*,*) 'ERROR IN THE DATA LINES OF DATA FILE'
      IF (ERROR.EQ.23) write(*,*) 'ERROR NOT IMPLEMENTED'
      IF (ERROR.EQ.24) WRITE(*,*) 'BACKGROUND FILE NOT FOUND'
      IF (ERROR.EQ.25) WRITE(*,*) 'ERROR READING START/STEP/STOP ANGLES'
      IF (ERROR.EQ.26) WRITE(*,*) 'ERROR IN READING DATA POINTS'
      IF (ERROR.EQ.27) WRITE(*,*) 'BCK START IS LARGER THAN DATA START'
      IF (ERROR.EQ.28) WRITE(*,*) 'BCK STEP IS DIFFERENT THAN DATA STEP'
      IF (ERROR.EQ.29) WRITE(*,*) 'BCK STOP IS SMALLER THAN DATA STOP'
      IF (ERROR.EQ.31) WRITE(*,*) 'Premature end of input file'
      IF (ERROR.EQ.32) WRITE(*,*) ''
      IF (ERROR.EQ.33) WRITE(*,*) 'Error reading background file'
      IF (ERROR.EQ.34) WRITE(*,*) 'Error reading input file'
      IF (ERROR.EQ.35) WRITE(*,*) 'Too many histograms'
      IF (ERROR.EQ.37) WRITE(*,*) 'Atom types for restraints not valid'
      IF (ERROR.EQ.38) WRITE(*,*) 'Invalid phase number in restraints'
      IF (ERROR.EQ.41) WRITE(*,*) 'Too many excluded regions'
      IF (ERROR.EQ.43) WRITE(*,*) 'Too many scattering entries'
      IF (ERROR.EQ.44) WRITE(*,*) 'More variables than allowed'
      IF (ERROR.EQ.45) WRITE(*,*) 'Illegal jobtype'
      IF (ERROR.EQ.46) WRITE(*,*) 'Q.R=0 in amorp. back. deriv.'
      IF (ERROR.EQ.50) WRITE(*,*) 'Scattering coeff. not found'
      IF (ERROR.EQ.51) WRITE(*,*) 'Error in Space Group'
      IF (ERROR.EQ.52) WRITE(*,*) 'No reflections found'
      IF (ERROR.EQ.53) WRITE(*,*) 'Preferred orientation usage invalid'
      IF (ERROR.EQ.54) WRITE(*,*) 'Asymmetry usage invalid'
      IF (ERROR.EQ.56) WRITE(*,*) 'Excessive peak overlap'
      IF (ERROR.EQ.60) WRITE(*,*) 'Q.R=0 in amorp. back. calc.'
      IF (ERROR.EQ.61) WRITE(*,*) '1/0 in interpolated background'
      IF (ERROR.EQ.70) WRITE(*,*) 'No file for LeBail Method'
      IF (ERROR.EQ.71) WRITE(*,*) 'Error reading hkl file'
      IF (ERROR.EQ.100) WRITE(*,*) 'Memory allocation error'
      ENDIF
      IF (ERR2.EQ.101) WRITE(*,*) 'Memory dallocation error'
      END                                        
      
      FUNCTION IGETSYSTEM()
      IGETSYSTEM = 0
      RETURN
      END                         
c  